## hintview 1.3.1

=== Linux/Makefile ===

# testing gtk options
ifndef WITH_GTK
WITH_GTK=0
endif

ifeq ($(WITH_GTK),0)

GTK_CFLAGS = -DWITH_GTK=0
GTL_LIBS = 
else ifeq ($(WITH_GTK),2)
PKGCONFIG = $(shell which pkg-config)
GTK_CFLAGS = $(shell $(PKGCONFIG) --cflags gtk+-2.0) -DWITH_GTK=2
GTK_LIBS = $(shell $(PKGCONFIG) --libs gtk+-2.0)
else ifeq ($(WITH_GTK),3)
PKGCONFIG = $(shell which pkg-config)
GTK_CFLAGS = $(shell $(PKGCONFIG) --cflags gtk+-3.0) -DWITH_GTK=3
GTK_LIBS = $(shell $(PKGCONFIG) --libs gtk+-3.0)
else
$(error "Valid values for WITH_GTK are 0, 2 or 3")
endif

CC = gcc
CFLAGS = -g -O0 -ggdb -DDEBUG -Wall -I../backend
LDFLAGS = -g -Og
#GL_DEFINES = -DGLEW_STATIC -DTW_NO_DIRECT3D -DTW_NO_LIB_PRAGMA -DTW_STATIC -D_CRT_SECURE_NO_WARNINGS

FT_INCLUDES = -I/usr/include/freetype2
GL_INCLUDES = $(FT_INCLUDES)


HFILES =     hint.h htex.h format.h get.h basetypes.h error.h \
	     hrender.h rendernative.h hfonts.h

WFILES =     format.w hint.w htex.ch btex.w

OBJ=main.o  renderOGL.o get.o hint.o tables.o htex.o hrender.o hfonts.o

ifeq (Msys,$(shell uname -o))
LIBS= ../external/glfw-3.1.2/msys.build/src/libglfw3.a ../external/libglew.a  -lfreetype \
	       -lm -lz
#	 -ldl -lm -lX11 -lpthread -lXrandr -lXinerama -lXi -lXcursor -lGL -lz
else
LIBS= -lglfw -lGLEW -ldl -lfreetype -lX11 -lXrandr -lXinerama -lXi -lXcursor -lGL -lz -lpthread -lm 
endif

all: hintview

.SUFFIXES:            # Delete the default suffixes

%.c: %.w
	echo running ctangle disabled

main.o: main.c
	$(CC) $(CFLAGS) $(GTK_CFLAGS) -o $@ -c $< 

hint.o: ../backend/hint.c
	$(CC) $(CFLAGS) -Wno-unused-but-set-variable -o $@ -c $<

htex.o: ../backend/htex.c
	$(CC) $(CFLAGS) -Wno-parentheses -Wno-unused-but-set-variable -Wno-maybe-uninitialized -o $@ -c $<

renderOGL.o: renderOGL.c
	$(CC) $(FT_INCLUDES) $(CFLAGS) -o $@ -c $<

hfonts.o: ../backend/hfonts.c
	$(CC) $(CFLAGS) $(FT_INCLUDES) -o $@ -c $<

%.o: ../backend/%.c 
	$(CC) $(CFLAGS) -o $@ -c $<

hintview: $(OBJ)
	$(CC) $(LDFLAGS) $(OBJ) $(LIBS) $(GTK_LIBS) -o $@ 

SRC= $(OBJ:.o=.c) $(HFILES) main.h stb_image.h Makefile CMakeLists.txt
DIST_SRC = $(SRC:%=src/%)
DIST_MAN = man/hintview.1

BINDIR=/usr/local/bin
MANDIR=/usr/local/man

install: hintview
	strip hintview
	install -t $(BINDIR) --mode=755 hintview
	install -t $(MANDIR)/man1 --mode=644 ../man/hintview.1

.PHONY: clean
clean:
	rm -f *.o *~ *.dvi *.log *.aux
	rm -f hintview

=== debian/changelog ===
hintview (1.3.1-1build2) noble; urgency=medium

  * No-change rebuild for CVE-2024-3094

 -- William Grant <wgrant@ubuntu.com>  Mon, 01 Apr 2024 16:56:47 +1100

hintview (1.3.1-1build1) noble; urgency=medium

  * No-change rebuild against libglib2.0-0t64

 -- Steve Langasek <steve.langasek@ubuntu.com>  Fri, 08 Mar 2024 05:04:10 +0000

hintview (1.3.1-1) unstable; urgency=medium

  * Initial release. (Closes: #1041668)

 -- Hilmar Preusse <hille42@web.de>  Thu, 20 Jul 2023 18:39:00 +0200

=== debian/control ===
Source: hintview
Section: text
Priority: optional
Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
XSBC-Original-Maintainer: Debian TeX Task Force <debian-tex-maint@lists.debian.org>
Uploaders: Hilmar Preusse <hille42@web.de>
Rules-Requires-Root: no
Build-Depends:
 debhelper-compat (= 13),
 libglfw3-dev,
 libglew-dev,
 libfreetype-dev,
 libftgl-dev,
 libxrandr-dev,
 libxinerama-dev,
 libxi-dev,
 libxcursor-dev,
 libopengl-dev,
 zlib1g-dev,
 libgtk-3-dev
Standards-Version: 4.6.2
Homepage: https://hint.userweb.mwn.de/hint/hintview.html
Vcs-Browser: https://github.com/debian-tex/hintview
Vcs-Git: https://github.com/debian-tex/hintview.git

Package: hintview
Architecture: any
Depends:
 ${shlibs:Depends},
 ${misc:Depends},
Description: Program to view HINT files
 The HINT file format is an alternative to the DVI or PDF format
 that was designed specifically for on screen reading of documents.
 Especially on mobile devices, reading DVI or PDF documents can be
 cumbersome.
 .
 Mobile devices are available in a large variety of sizes but are
 typically not large enough to display documents formatted for
 letter-size paper. To compensate for the limitations of a small
 screen, users are used to alternate between landscape (few long
 lines) and portrait (more short lines) mode. The HINT format
 supports variable and varying screen sizes leveraging the ability
 of TeX to format a document for (almost) arbitrary values of
 \hsize and \vsize.

=== debian/rules ===
#!/usr/bin/make -f

# See debhelper(7) (uncomment to enable).
# Output every command that modifies files on the build system.
#export DH_VERBOSE = 1


# See FEATURE AREAS in dpkg-buildflags(1).
#export DEB_BUILD_MAINT_OPTIONS = hardening=+all

# See ENVIRONMENT in dpkg-buildflags(1).
# Package maintainers to append CFLAGS.
#export DEB_CFLAGS_MAINT_APPEND  = -Wall -pedantic
# Package maintainers to append LDFLAGS.
#export DEB_LDFLAGS_MAINT_APPEND = -Wl,--as-needed

%:
	dh $@

override_dh_auto_build:
	cd Linux; WITH_GTK=3 make

#override_dh_auto_configure:
#	dh_auto_configure -- \
#	-DCMAKE_LIBRARY_PATH=$(DEB_HOST_MULTIARCH)

## hintview 2.1.0

=== Linux/Makefile ===
--- 
+++ 
@@ -51,6 +51,13 @@
 %.c: %.w
 	echo running ctangle disabled
 
+-include .depend
+
+.depend: main.c  renderOGL.c 
+	$(CC) -I../backend -MM *.c  > $@ || true
+
+
+
 main.o: main.c
 	$(CC) $(CFLAGS) $(GTK_CFLAGS) -o $@ -c $< 
 
@@ -69,7 +76,9 @@
 %.o: ../backend/%.c 
 	$(CC) $(CFLAGS) -o $@ -c $<
 
+# copy the .w files for gdb
 hintview: $(OBJ)
+	cp ../backend/*.w .
 	$(CC) $(LDFLAGS) $(OBJ) $(LIBS) $(GTK_LIBS) -o $@ 
 
 SRC= $(OBJ:.o=.c) $(HFILES) main.h stb_image.h Makefile CMakeLists.txt
@@ -82,7 +91,7 @@
 install: hintview
 	strip hintview
 	install -t $(BINDIR) --mode=755 hintview
-	install -t $(MANDIR)/man1 --mode=644 ../man/hintview.1
+	install -t $(MANDIR)/man1 --mode=644 hintview.1
 
 .PHONY: clean
 clean:

=== Linux/tests/Makefile ===

STRETCH=~/gitlab/hint/format/stretch
SHRINK=~/gitlab/hint/format/shrink


%.hnt: %.hint
	$(SHRINK) $<

%.hnt: %.tex
	hitex $<

%.hint: %.hnt
	$(STRETCH) $<

=== debian/changelog ===
hintview (2.1.0-1) unstable; urgency=medium

  * New upstream version, obsoletes patches.

 -- Hilmar Preuße <hille42@debian.org>  Mon, 09 Dec 2024 21:53:34 +0100

=== debian/control ===
--- 
+++ 
@@ -1,9 +1,8 @@
 Source: hintview
 Section: text
 Priority: optional
-Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
-XSBC-Original-Maintainer: Debian TeX Task Force <debian-tex-maint@lists.debian.org>
-Uploaders: Hilmar Preusse <hille42@web.de>
+Maintainer: Debian TeX Task Force <debian-tex-maint@lists.debian.org>
+Uploaders: Hilmar Preuße <hille42@debian.org>
 Rules-Requires-Root: no
 Build-Depends:
  debhelper-compat (= 13),

## hintview 2.3.0

=== Linux/Makefile ===

PKG_CONFIG ?= pkg-config

GTK_CFLAGS = $(shell $(PKG_CONFIG) --cflags gtk+-3.0) 
GTK_LIBS = $(shell $(PKG_CONFIG) --libs gtk+-3.0)


CC= gcc
ifdef DEBUG
CFLAGS = -g -O0 -ggdb -DDEBUG -DHAVE_HINT_ERROR -DHAVE_HINT_MESSAGE -Wall -I../backend
LDFLAGS = -g -Og -ggdb
else
CFLAGS = -O2 -Wall -I../backend -DHAVE_HINT_ERROR -DHAVE_HINT_MESSAGE
LDFLAGS = -O2
endif


ifeq (Msys,$(shell uname -o))
FT_INCLUDES = -I/mingw64/include/freetype2 
LIBS = -lglew32 -lopengl32 -lfreetype -lz -lm
else
FT_INCLUDES = -I/usr/include/freetype2
LIBS = -lGLEW -lGL -lfreetype -lz -lm
endif


SRC= about.c main.c preferences.c resources.c settings.c \
	header.c outline.c renderOGL.c search.c 

OBJ= main.o renderOGL.o get.o hint.o tables.o \
 search.o  outline.o header.o settings.o about.o\
 resources.o preferences.o


all: hintview

%.c: %.w
	echo running ctangle disabled

-include .depend



.depend: $(SRC)
	$(CC) -I../backend -MM *.c  > $@ || true

main.o: main.c
	$(CC) $(CFLAGS) $(GTK_CFLAGS) -o $@ -c $< 

renderOGL.o: renderOGL.c
	$(CC) $(CFLAGS) $(FT_INCLUDES) -o $@ -c $< 

hint.o: ../backend/hint.c
	$(CC) $(CFLAGS) $(FT_INCLUDES) -o $@ -c $<

%.o: ../backend/%.c 
	$(CC) $(CFLAGS) $(FT_INCLUDES)  -o $@ -c $<

hintview: $(OBJ)
	$(CC) $(LDFLAGS) $(OBJ) $(GTK_LIBS) $(LIBS) -o $@
	cp ../backend/*.w .


message.o: message.c
	$(CC) $(CFLAGS) $(GTK_CFLAGS) -o $@ -c $< 

message: message.o
	$(CC) $(LDFLAGS) $< $(GTK_LIBS) -o $@

search.o: search.c
	$(CC) $(CFLAGS) $(GTK_CFLAGS) -o $@ -c $< 

search: search.o
	$(CC) $(LDFLAGS) $< $(GTK_LIBS) -o $@


outline.o: outline.c
	$(CC) $(CFLAGS) $(GTK_CFLAGS) -o $@ -c $< 

outline: outline.o
	$(CC) $(LDFLAGS) $< $(GTK_LIBS) -o $@

header.o: header.c
	$(CC) $(CFLAGS) $(GTK_CFLAGS) -o $@ -c $< 

header: header.o
	$(CC) $(LDFLAGS) $< $(GTK_LIBS) -o $@

preferences.o: preferences.c
	$(CC) $(CFLAGS) $(GTK_CFLAGS) -o $@ -c $< 

preferences: preferences.o
	$(CC) $(LDFLAGS) $< $(GTK_LIBS) -o $@

about.o: about.c
	$(CC) $(CFLAGS) $(GTK_CFLAGS) -o $@ -c $< 

about: about.o
	$(CC) $(LDFLAGS) $< $(GTK_LIBS) -o $@


resources.o: resources.c resources.h
	$(CC) $(CFLAGS) $(GTK_CFLAGS) -o $@ -c $< 

resources.c: resources.xml # help.sgml
	glib-compile-resources --generate-source  resources.xml 

resources.h: resources.xml
	glib-compile-resources --generate-header  resources.xml 

settings.o: settings.c
	$(CC) $(CFLAGS) $(GTK_CFLAGS) -o $@ -c $< 

settings: settings.o
	$(CC) $(LDFLAGS) $< $(GTK_LIBS) -o $@

BINDIR=/usr/local/bin
MANDIR=/usr/local/man

hintview.hnt: hintview.tex
	hitex hintview.tex

install: hintview
	strip hintview
	install -t $(BINDIR) --mode=755 hintview
	install -t $(MANDIR)/man1 --mode=644 hintview.1



.PHONY: install_schema
install_schema: edu.hm.cs.hintview.gschema.xml
	sudo install edu.hm.cs.hintview.gschema.xml /usr/share/glib-2.0/schemas/
	sudo glib-compile-schemas /usr/share/glib-2.0/schemas/



ICON_DIR=/usr/share/icons/hicolor
ICON_NAME=mimetypes/x-hintview.png
# Works also: ICON_NAME=apps/x-hintview.png
#ICON_SRC= ../resources/logo/HINTLogoBuchGrey
ICON_SRC= ../resources/logo/HINTLogoBuchFG
ICON_SIZE = 16 32 48 64 128 256 512

ICONS = $(patsubst %,$(ICON_SRC)%.png,$(ICON_SIZE))


.PHONY: install_icons
install_icons: hintview.xml
	sudo install hintview.xml /usr/share/mime/packages
	sudo update-mime-database /usr/share/mime/
	for i in $(ICON_SIZE) ; do\
	  sudo install $(ICON_SRC)$$i.png $(ICON_DIR)/"$$i"x"$$i"/$(ICON_NAME) ;\
	done
	sudo gtk-update-icon-cache  $(ICON_DIR)

.PHONY: delete_icons
delete_icons:
	for i in $(ICON_SIZE) ; do\
	  sudo rm -f $(ICON_DIR)/"$$i"x"$$i"/$(ICON_NAME) ;\
	done
	sudo gtk-update-icon-cache  $(ICON_DIR)


.PHONY: clean
clean:
	rm -rf *~ *.o *.log *.w
	rm -rf hintview .depend TAGS

=== debian/changelog ===
hintview (2.3.0-1) unstable; urgency=medium

  * New upstream version.
    - Fixes FTCBFS: (Closes: #1115555).
      Thanks to Helmut Grohne for report and creating the original
      patch.

  * Better Desktop integration.
    - New MIME Type for .hnt files; associate hintview to that MIME Type.
    - Integrate into start menu + Icon for .hnt files.
  * Package build log passes blhc test (Closes: #1119442)
  * Bump Standards version, no changes needed.

 -- Hilmar Preuße <hille42@debian.org>  Tue, 11 Nov 2025 22:24:02 +0100

=== debian/control ===
--- 
+++ 
@@ -17,7 +17,7 @@
  libopengl-dev,
  zlib1g-dev,
  libgtk-3-dev
-Standards-Version: 4.6.2
+Standards-Version: 4.7.2
 Homepage: https://hint.userweb.mwn.de/hint/hintview.html
 Vcs-Browser: https://github.com/debian-tex/hintview
 Vcs-Git: https://github.com/debian-tex/hintview.git

=== debian/rules ===
--- 
+++ 
@@ -6,7 +6,7 @@
 
 
 # See FEATURE AREAS in dpkg-buildflags(1).
-#export DEB_BUILD_MAINT_OPTIONS = hardening=+all
+export DEB_BUILD_MAINT_OPTIONS = hardening=+all
 
 # See ENVIRONMENT in dpkg-buildflags(1).
 # Package maintainers to append CFLAGS.
@@ -14,11 +14,30 @@
 # Package maintainers to append LDFLAGS.
 #export DEB_LDFLAGS_MAINT_APPEND = -Wl,--as-needed
 
+package = hintview
+
+ICON_DIR := /usr/share/icons/hicolor
+ICON_NAME := mimetypes/x-hintview.png
+ICON_SRC := resources/logo/HINTLogoBuchFG
+ICON_SIZE = 16 32 48 64 128 256 512
+
+export DEB_CFLAGS_MAINT_APPEND += -I../backend -DHAVE_HINT_ERROR -DHAVE_HINT_MESSAGE
+
 %:
 	dh $@
 
 override_dh_auto_build:
-	cd Linux; WITH_GTK=3 make
+	WITH_GTK=3 dh_auto_build --sourcedirectory=Linux
+
+execute_after_dh_install:
+	for i in $(ICON_SIZE); do \
+		mkdir -p $(CURDIR)/debian/$(package)/$(ICON_DIR)/"$$i"x"$$i"/mimetypes; \
+		install $(ICON_SRC)$$i.png $(CURDIR)/debian/$(package)/$(ICON_DIR)/"$$i"x"$$i"/$(ICON_NAME); \
+	done
+	install debian/hintview.desktop $(CURDIR)/debian/$(package)/usr/share/applications/
+
+execute_after_dh_clean:
+	rm -f Linux/*.o Linux/*.w Linux/hintview Linux/.depend
 
 #override_dh_auto_configure:
 #	dh_auto_configure -- \
